package biblioteca;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.border.EmptyBorder;

public class Main extends JFrame {

	private Vector elenco;

	private JPanel contentPane;
	private JTextArea textElenco;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		elenco = new Vector(100, 1);
		
		
		setTitle("Biblioteca");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);

		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);

		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);

		JMenuItem mntmNuovo = new JMenuItem("Nuovo");
		mntmNuovo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				nuovaRubrica();
			}
		});
		mntmNuovo.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.CTRL_MASK));
		mnFile.add(mntmNuovo);

		JMenuItem mntmApri = new JMenuItem("Apri");
		mntmApri.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				apriBiblioteca();
			}
		});
		mntmApri.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, InputEvent.CTRL_MASK));
		mnFile.add(mntmApri);

		JMenuItem mntmSalva = new JMenuItem("Salva");
		mntmSalva.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				salvaBiblioteca();
			}
		});
		mntmSalva.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, InputEvent.CTRL_MASK));
		mnFile.add(mntmSalva);

		JMenu mnModifica = new JMenu("Modifica");
		menuBar.add(mnModifica);

		JMenuItem mntmAggiungiLibro = new JMenuItem("Aggiungi libro");
		mntmAggiungiLibro.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				aggiungiLibro();
			}
		});
		mnModifica.add(mntmAggiungiLibro);

		JMenuItem mntmEliminaLibro = new JMenuItem("Elimina libro");
		mntmEliminaLibro.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				eliminaLibro();
			}
		});
		mnModifica.add(mntmEliminaLibro);

		JMenuItem mntmVisualizzaLibro = new JMenuItem("Visualizza libro");
		mntmVisualizzaLibro.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				visualizzaLibro();
			}
		});
		mnModifica.add(mntmVisualizzaLibro);
		
		JMenu mnRicerca = new JMenu("Ricerca");
		menuBar.add(mnRicerca);
		
		JMenuItem mntmRicercaPerAutore = new JMenuItem("Ricerca per autore");
		mntmRicercaPerAutore.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				ricercaPerAutore();
			}
		});
		mnRicerca.add(mntmRicercaPerAutore);
		
		JMenuItem mntmRicercaPerTitolo = new JMenuItem("Ricerca per titolo");
		mnRicerca.add(mntmRicercaPerTitolo);

		JMenu mnNewMenu = new JMenu("?");
		menuBar.add(mnNewMenu);

		JMenuItem mntmInformazioniSu = new JMenuItem("Informazioni su...");
		mntmInformazioniSu.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				new InformazioniSu().setVisible(true);
			}
		});
		mnNewMenu.add(mntmInformazioniSu);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JScrollPane scrollPane = new JScrollPane();
		contentPane.add(scrollPane, BorderLayout.CENTER);

		textElenco = new JTextArea();
		textElenco.setEditable(false);
		scrollPane.setViewportView(textElenco);
	}

	private void aggiungiLibro() {

		String autore = null;
		String titolo = null;
		String editore = null;
		int pagine = 0;
		double prezzo = 0.0;
		String isbn = null;

		while (autore == null)
			autore = JOptionPane.showInputDialog(textElenco, "Inserisci il titolo", "Inserimento",
					JOptionPane.QUESTION_MESSAGE);
		while (titolo == null)
			titolo = JOptionPane.showInputDialog(textElenco, "Inserisci l'autore", "Inserimento",
					JOptionPane.QUESTION_MESSAGE);
		while (editore == null)
			editore = JOptionPane.showInputDialog(textElenco, "Inserisci l'editore", "Inserimento",
					JOptionPane.QUESTION_MESSAGE);
		while (pagine == 0)
			pagine = Integer.parseInt(JOptionPane.showInputDialog(textElenco, "Inserisci il numero di pagine", "Inserimento",
					JOptionPane.QUESTION_MESSAGE));
		while (prezzo == 0.0)
			prezzo = Double.parseDouble(JOptionPane.showInputDialog(textElenco, "Inserisci il prezzo", "Inserimento",
					JOptionPane.QUESTION_MESSAGE));
		while (isbn == null)
			isbn = JOptionPane.showInputDialog(textElenco, "Inserisci il codice isbn", "Inserimento",
					JOptionPane.QUESTION_MESSAGE);

		Libro libro = new Libro(autore, titolo, editore, pagine, prezzo, isbn);
		elenco.addElement(libro);
		visualizzaLibro();
	}

	private void eliminaLibro() {
		int titolo = -1;

		while (titolo == -1)
			titolo = Integer.parseInt(JOptionPane.showInputDialog(textElenco,
					"Inserisci il numero del titolo da eliminare", "Inserimento", JOptionPane.QUESTION_MESSAGE));

		elenco.removeElementAt(titolo - 1);

		visualizzaLibro();
	}

	private void visualizzaLibro() {
		textElenco.setText("");

		for (int i = 0; i < elenco.size(); i++) {
			Libro libro = (Libro) elenco.elementAt(i);
			textElenco.append(i + 1 + ".\n" + libro.toString() + "\n");
		}
	}

	private void nuovaRubrica() {
		int risposta = JOptionPane.showConfirmDialog(textElenco, "Vuoi veramente cancellare l'archivio in memoria?",
				"Avviso", JOptionPane.OK_CANCEL_OPTION);
		if (risposta == JOptionPane.OK_OPTION)
			elenco.clear();

		visualizzaLibro();
	}

	private void apriBiblioteca() {
		elenco.clear();

		try {
			FileReader fr = new FileReader("Biblioteca.csv");
			BufferedReader br = new BufferedReader(fr);

			String linea;
			while ((linea = br.readLine()) != null) {
				String[] dati = linea.split(";");
				Libro libro = new Libro();
				libro.setAutore(dati[0]);
				libro.setTitolo(dati[1]);
				libro.setEditore(dati[2]);
				libro.setPagine(Integer.parseInt(dati[3]));
				libro.setPrezzo(Double.parseDouble(dati[4]));
				libro.setIsbn(dati[5]);
				elenco.addElement(libro);
			}

			br.close();
			fr.close();
			JOptionPane.showMessageDialog(textElenco, "Caricamento completato", "Informazioni",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(textElenco, "Errore lettura file:\n" + e.toString(), "Errore",
					JOptionPane.ERROR_MESSAGE);
		}

		visualizzaLibro();
	}

	private void salvaBiblioteca() {
		try {
			FileWriter fw = new FileWriter("Biblioteca.csv");
			BufferedWriter bw = new BufferedWriter(fw);

			for (int i = 0; i < elenco.size(); i++) {
				Libro libro = (Libro) elenco.elementAt(i);
				bw.write(libro.toFile());
				bw.newLine();
			}

			bw.close();
			fw.close();
			JOptionPane.showMessageDialog(textElenco, "Salvataggio completato", "Informazioni",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException e) {
			JOptionPane.showMessageDialog(textElenco, "Errore scrittura file:\n" + e.toString(), "Errore",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void ricercaPerAutore() {
		String autore = null;

		while (autore == null)
			autore = JOptionPane.showInputDialog(textElenco, "Inserisci l'autore:", "Ricerca per autore",
					JOptionPane.QUESTION_MESSAGE);
		
		textElenco.setText("Ricerca per autore = " + autore + "\n\n");
		for (int i = 0; i < elenco.size(); i++) {
			Libro libro = (Libro) elenco.elementAt(i);
			if (libro.getAutore().equals(autore))
					textElenco.append(i + 1 + ". " + libro.toString() + "\n");
		}
	}

}
